#include "myTerrainTechnique.h"
#include <osgTerrain/TerrainTile>

using namespace osgTerrain;

myTerrainTechnique::myTerrainTechnique(void) : osgTerrain::GeometryTechnique()
{
	//OSG_ALWAYS<<className()<<"Constructed by Constructor"<<std::endl;

}

myTerrainTechnique::myTerrainTechnique(const GeometryTechnique& TerrainTechnique,const osg::CopyOp& copyop):
	osgTerrain::GeometryTechnique(TerrainTechnique,copyop)
{
	//OSG_ALWAYS<<className()<<"Constructed by Copy-Constructor"<<std::endl;
}

myTerrainTechnique::~myTerrainTechnique(void)
{
}

void myTerrainTechnique::init(int dirtyMask, bool assumeMultiThreaded)
{
	/* The heightfield es extracted from the tile in the techniques init function. technique->init() calls  technique->generateGeometry() which creates the drawable according to the heightfield.
	To modify the height, the heightfield must be modified prior to the original techniques init() function.

	To modiy the drawable shape (e.g. Cutting wholes in the area), the function technique->generateGeometry() must be modified.
	*/

	HeightFieldLayer* hfl = dynamic_cast<HeightFieldLayer*>( getTerrainTile()->getElevationLayer() );
	osg::HeightField* h = hfl->getHeightField();
	h->setHeight( 0,0, 1000);

	 ImageLayer* il = dynamic_cast<ImageLayer*>( getTerrainTile()->getColorLayer(0) );
	 osg::Image* img = il->getImage();
	 img->setInternalTextureFormat( GL_RGBA );

	 osg::ref_ptr<osg::Image> img2 = new osg::Image();
	 img2->setInternalTextureFormat( GL_RGBA );
	 img2->alloc

    GeometryTechnique::init(dirtyMask, assumeMultiThreaded);
}